=== debian/changelog ===
davs2 (1.6-1~exp2) experimental; urgency=medium

  * Add patch 1002 to fix architecture optimization.
    Stop avoid assembler on 32bit architectures.
  * Add patches cherry-picked upstream:
    + Make AVX symbols to be strictly visible (fix build with gcc8).
    + Fix write one more line in intra_pred_ver_sse128().
    + Fix avoid duplicate content when passing parameter -h or --help.
    + Change the help text to English.
  * Fix clean leftover objects and generated header after build.
  * Add symbols file.
  * Wrap and sort control file.
  * Resolve dependencies for and install shared library with d-shlibs.
  * Update help2man post-scrubbing.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 25 Dec 2018 14:05:38 +0100

davs2 (1.6-1~exp1) experimental; urgency=low

  * Initial packaging release.
    Closes: bug#917172.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 23 Dec 2018 19:18:37 +0100
