=== debian/control ===
--- 
+++ 
@@ -5,11 +5,10 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
- d-shlibs,
  debhelper,
+ pkg-kde-tools,
+ nasm,
  help2man,
- pkg-kde-tools,
- yasm,
 Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/multimedia-team/davs2.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/davs2
@@ -19,8 +18,8 @@
 Architecture: any
 Depends:
  libdavs2-16 (= ${binary:Version}),
+ ${shlibs:Depends},
  ${misc:Depends},
- ${shlibs:Depends},
 Description: AVS2 (IEEE 1857.4) decoder - command-line tool
  davs2 is an decoder for the AVS2-P2/IEEE1857.4 video codec.
  .
